/**
 | Structures for the lex&yacc desktop calculator (dtc)
 | From the bison manual example, modified by MLO
 | $Id: dtcdef.h,v 1.3 2000/04/06 08:20:06 loreti Exp $
**/

/**
 | General structure for name/entity of type "type" correspondence,
 | to be inserted in a binary tree
**/

typedef struct sSymRec {
  struct sSymRec *left;
  struct sSymRec *right;
  int type;
  union {
    double var;
    double (*d_funptr)();
    void   (*v_funptr)();
  } value;
  char name[1];
} symRec;

/**
 | Procedure to store or retrieve a symRec in the binary tree
**/

symRec *insertNode(symRec *, const char *, int *, symRec **);

/**
 | Specializations for correspondences function name/function;
 | constant name/value; conversion function/function.
**/

typedef struct sFunTable {
  char    *name;
  double (*fun)(double);
} funTable;

typedef struct sConstTable {
  char   *name;
  double  value;
} constTable;

typedef struct sSpecialTable {
  char  *name;
  void (*fun)(void);
} specTable;
